/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks of the Open-Xchange, Inc. group of companies.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2004-2013 Open-Xchange, Inc.
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package com.openexchange.git.conflict;

import java.util.List;
import com.openexchange.git.MergeException;
import com.openexchange.git.data.Conflict;

/**
 * {@link Manifest}
 *
 * @author <a href="mailto:marcus.klein@open-xchange.com">Marcus Klein</a>
 */
public final class Manifest implements Solver {

    public Manifest() {
        super();
    }

    public boolean applies(Conflict conflict) {
        // TODO Auto-generated method stub

//        <<<<<<< HEAD
//        Bundle-Version: 7.0.1
//        =======
//        Bundle-Version: 6.22.0
//        OXVersion: 6.22.0
//        OXRevision: 9
//        >>>>>>> hotfix-1289

//        <<<<<<< HEAD
//        Bundle-Version: 7.0.1
//        OXVersion: 7.0.1
//        OXRevision: 5
//        =======
//        Bundle-Version: 7.0.2
//        OXVersion: 7.0.2
//        OXRevision: 6
//        >>>>>>> origin/release-7.0.2

//        <<<<<<< HEAD
//        Bundle-Version: 7.4.0
//        =======
//        Bundle-Version: 7.2.1
//        >>>>>>> release-7.2.1
        List<String> here = conflict.getHere();
        List<String> there = conflict.getThere();
        if (here.size() != 1) {
            return false;
        }
        if (there.size() != 1) {
            return false;
        }
//        return here.get(0).startsWith("Bundle-Version: ") && there.get(0).startsWith("Bundle-Version: ");
        // For safety and unimplemented cases return false. I can not detect currently that the here branch is develop.
        return false;
    }

    public List<String> solve(Conflict conflict) throws MergeException {
        // Merging into master should not give above tested conflict. So solve only merging into develop which can be already on a much
        // higher version.
        return conflict.getHere();
    }
}
